﻿//TODO: Include this header file in App.xaml.h or pch.h to avoid errors in generated code
//
// MyDirectXControl.h
// Declaration of the MyDirectXControl class.
//

#pragma once
#include <d3d11_1.h>
#include <dxgi1_2.h>
#include <wrl.h>
#include <windows.ui.xaml.media.dxinterop.h>

#include "pch.h"

namespace MyControlsLibrary
{
	public ref class MyDirectXControl sealed : public Windows::UI::Xaml::Controls::Control
	{
	public:
		MyDirectXControl();
		virtual void OnApplyTemplate() override;
		void Refresh();

	private:
		//private methods
		Windows::UI::Xaml::Media::Imaging::SurfaceImageSource^ CreateImageSource(int width, int height);
		void OnMapSurfaceSizeChanged(Platform::Object^ sender, Windows::UI::Xaml::SizeChangedEventArgs^ e);
		void Draw(int width, int height);

		//private fields
		// template child that holds the UI Element
		Windows::UI::Xaml::Controls::Border^				m_MapSurfaceElement;
		// surface image source
	    Windows::UI::Xaml::Media::Imaging::SurfaceImageSource^ m_imageSource;
		// Native interface of the surface image source
		Microsoft::WRL::ComPtr<ISurfaceImageSourceNative>	m_imageSourceNative;
		// D3D device
		Microsoft::WRL::ComPtr<ID3D11Device>				m_d3dDevice;
		Microsoft::WRL::ComPtr<ID3D11DeviceContext>			m_d3dContext;
		Windows::Foundation::EventRegistrationToken _sizeChangedToken;
	};
}
